"""
    Blockdaemon REST API

    Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet/testnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ubiquity.ubiquity_openapi_client.api_client import ApiClient, Endpoint as _Endpoint
from ubiquity.ubiquity_openapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from ubiquity.ubiquity_openapi_client.model.error import Error
from ubiquity.ubiquity_openapi_client.model.signed_tx import SignedTx
from ubiquity.ubiquity_openapi_client.model.tx import Tx
from ubiquity.ubiquity_openapi_client.model.tx_confirmation import TxConfirmation
from ubiquity.ubiquity_openapi_client.model.tx_create import TxCreate
from ubiquity.ubiquity_openapi_client.model.tx_output import TxOutput
from ubiquity.ubiquity_openapi_client.model.tx_outputs import TxOutputs
from ubiquity.ubiquity_openapi_client.model.tx_page import TxPage
from ubiquity.ubiquity_openapi_client.model.tx_receipt import TxReceipt
from ubiquity.ubiquity_openapi_client.model.unsigned_tx import UnsignedTx


class TransactionsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __get_tx_by_hash(
            self,
            protocol="bitcoin",
            network="mainnet",
            hash="71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a",
            **kwargs
        ):
            """Get a Transaction  # noqa: E501

            Returns a transaction by a user-defined transaction hash.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_tx_by_hash(protocol="bitcoin", network="mainnet", hash="71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of: `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `optimism`, `polkadot`, `polygon`, `solana`, `stellar` `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                hash (str): The transaction hash.. defaults to "71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a", must be one of ["71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Tx
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['hash'] = \
                hash
            return self.call_with_http_info(**kwargs)

        self.get_tx_by_hash = _Endpoint(
            settings={
                'response_type': (Tx,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/tx/{hash}',
                'operation_id': 'get_tx_by_hash',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'hash',
                ],
                'required': [
                    'protocol',
                    'network',
                    'hash',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'hash':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'hash': 'hash',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'hash': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_tx_by_hash
        )

        def __get_tx_confirmations(
            self,
            protocol="bitcoin",
            network="mainnet",
            hash="71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a",
            **kwargs
        ):
            """Get the Transaction Confirmations  # noqa: E501

            Returns the number of transaction confirmations by a user-defined transaction hash.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_tx_confirmations(protocol="bitcoin", network="mainnet", hash="71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of: `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `optimism`, `polkadot`, `polygon`, `tezos`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                hash (str): The transaction hash.. defaults to "71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a", must be one of ["71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                TxConfirmation
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['hash'] = \
                hash
            return self.call_with_http_info(**kwargs)

        self.get_tx_confirmations = _Endpoint(
            settings={
                'response_type': (TxConfirmation,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/tx/{hash}/confirmations',
                'operation_id': 'get_tx_confirmations',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'hash',
                ],
                'required': [
                    'protocol',
                    'network',
                    'hash',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'hash':
                        (str,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'hash': 'hash',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'hash': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_tx_confirmations
        )

        def __get_tx_output_by_hash_and_index(
            self,
            protocol="bitcoin",
            network="mainnet",
            hash="71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a",
            index=0,
            **kwargs
        ):
            """Get a Transaction Output by Hash and Index  # noqa: E501

            Get a transaction output by a user-defined transaction hash and the transaction output index.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_tx_output_by_hash_and_index(protocol="bitcoin", network="mainnet", hash="71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a", index=0, async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of: `bitcoin`, `bitcoincash`, `dogecoin`, `litecoin`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                hash (str): The transaction hash.. defaults to "71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a", must be one of ["71d4f3412ec11128bbd9ce988d5bff2ec3bb6ea3953c8faf189d88ae49de9f7a"]
                index (int): The transaction output index.. defaults to 0, must be one of [0]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                TxOutput
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['hash'] = \
                hash
            kwargs['index'] = \
                index
            return self.call_with_http_info(**kwargs)

        self.get_tx_output_by_hash_and_index = _Endpoint(
            settings={
                'response_type': (TxOutput,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/tx/{hash}/{index}',
                'operation_id': 'get_tx_output_by_hash_and_index',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'hash',
                    'index',
                ],
                'required': [
                    'protocol',
                    'network',
                    'hash',
                    'index',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'hash':
                        (str,),
                    'index':
                        (int,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'hash': 'hash',
                    'index': 'index',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'hash': 'path',
                    'index': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_tx_output_by_hash_and_index
        )

        def __get_txs(
            self,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Get a List of Transactions  # noqa: E501

            Get a List of transactions, starting with the lastest one. Each call returns an array of the entire list.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_txs(protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): Protocol handle, one of: `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom` `litecoin`, `optimism`, `polkadot`, `polygon`, `stellar` `tezos`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                block_hash (str): Filter by block hash. You can specify only one block hash at a time.. [optional]
                block_number (int): Filter by block number.. [optional]
                assets (str): Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. Find all the asset paths on this [page](https://docs.blockdaemon.com/reference/available-currencies-and-tokens).. [optional]
                order (str): The pagination order.. [optional] if omitted the server will use the default value of "desc"
                page_token (str): The token to retrieve more items in the next request. Use the `next_page_token` returned from the previous response for this parameter.. [optional]
                page_size (int): Max number of items to return in a response. Defaults to 25 and is capped at 100. . [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                TxPage
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            return self.call_with_http_info(**kwargs)

        self.get_txs = _Endpoint(
            settings={
                'response_type': (TxPage,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/txs',
                'operation_id': 'get_txs',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'block_hash',
                    'block_number',
                    'assets',
                    'order',
                    'page_token',
                    'page_size',
                ],
                'required': [
                    'protocol',
                    'network',
                ],
                'nullable': [
                ],
                'enum': [
                    'order',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('order',): {

                        "DESC": "desc",
                        "ASC": "asc"
                    },
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'block_hash':
                        (str,),
                    'block_number':
                        (int,),
                    'assets':
                        (str,),
                    'order':
                        (str,),
                    'page_token':
                        (str,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'block_hash': 'block_hash',
                    'block_number': 'block_number',
                    'assets': 'assets',
                    'order': 'order',
                    'page_token': 'page_token',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'block_hash': 'query',
                    'block_number': 'query',
                    'assets': 'query',
                    'order': 'query',
                    'page_token': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_txs
        )

        def __get_txs_by_address(
            self,
            protocol="bitcoin",
            network="mainnet",
            address="1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa",
            **kwargs
        ):
            """Get a List of Transactions for a Given Address  # noqa: E501

            Returns the transactions that an address was involved with, from newest to oldest.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_txs_by_address(protocol="bitcoin", network="mainnet", address="1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): The protocol handle, one of: `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `optimism`, `polkadot`, `polygon`, `solana`, `tezos`, `stellar`, `xrp`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                address (str): The account address of the protocol.. defaults to "1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa", must be one of ["1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa"]

            Keyword Args:
                assets (str): Comma-separated list of asset paths to filter. If the list is empty, or all elements are empty, this filter has no effect. Find all the asset paths on this [page](https://docs.blockdaemon.com/reference/available-currencies-and-tokens).. [optional]
                _from (int): Unix Timestamp from where to start. [optional]
                to (int): Unix Timestamp from where to end. [optional]
                order (str): The pagination order.. [optional] if omitted the server will use the default value of "desc"
                page_token (str): The token to retrieve more items in the next request. Use the `next_page_token` returned from the previous response for this parameter.. [optional]
                page_size (int): Max number of items to return in a response. Defaults to 25 and is capped at 100. . [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                TxPage
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['address'] = \
                address
            return self.call_with_http_info(**kwargs)

        self.get_txs_by_address = _Endpoint(
            settings={
                'response_type': (TxPage,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/account/{address}/txs',
                'operation_id': 'get_txs_by_address',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'address',
                    'assets',
                    '_from',
                    'to',
                    'order',
                    'page_token',
                    'page_size',
                ],
                'required': [
                    'protocol',
                    'network',
                    'address',
                ],
                'nullable': [
                ],
                'enum': [
                    'order',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('order',): {

                        "DESC": "desc",
                        "ASC": "asc"
                    },
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'address':
                        (str,),
                    'assets':
                        (str,),
                    '_from':
                        (int,),
                    'to':
                        (int,),
                    'order':
                        (str,),
                    'page_token':
                        (str,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'address': 'address',
                    'assets': 'assets',
                    '_from': 'from',
                    'to': 'to',
                    'order': 'order',
                    'page_token': 'page_token',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'address': 'path',
                    'assets': 'query',
                    '_from': 'query',
                    'to': 'query',
                    'order': 'query',
                    'page_token': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_txs_by_address
        )

        def __get_utxoby_account(
            self,
            protocol="bitcoin",
            network="mainnet",
            address="1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa",
            **kwargs
        ):
            """Get a List of Transaction Inputs and Outputs  # noqa: E501

            Returns the transaction inputs and outputs following the BTC's UTXO model definition by a user-definied account address.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_utxoby_account(protocol="bitcoin", network="mainnet", address="1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa", async_req=True)
            >>> result = thread.get()

            Args:
                protocol (str): The protocol handle, one of: `bitcoin`, `bitcoincash`, `dogecoin`, `litecoin`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]
                address (str): The account address of the protocol.. defaults to "1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa", must be one of ["1A1zP1eP5QGefi2DMPTfTL5SLmv7DivfNa"]

            Keyword Args:
                spent (bool): Whether the transaction output was spent or not.. [optional]
                check_mempool (bool): Whether to check for UTXOs spent in the mempool as well as UTXOs pending in the mempool.. [optional]
                _from (int): The Unix Timestamp from where to start.. [optional]
                to (int): The Unix Timestamp from where to end.. [optional]
                order (str): The pagination order.. [optional] if omitted the server will use the default value of "desc"
                page_token (str): The token to retrieve more items in the next request. Use the `next_page_token` returned from the previous response for this parameter.. [optional]
                page_size (int): The max number of items to return in a response Defaults to 50k and is capped at 100k. . [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                TxOutputs
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['address'] = \
                address
            return self.call_with_http_info(**kwargs)

        self.get_utxoby_account = _Endpoint(
            settings={
                'response_type': (TxOutputs,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/account/{address}/utxo',
                'operation_id': 'get_utxoby_account',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'address',
                    'spent',
                    'check_mempool',
                    '_from',
                    'to',
                    'order',
                    'page_token',
                    'page_size',
                ],
                'required': [
                    'protocol',
                    'network',
                    'address',
                ],
                'nullable': [
                ],
                'enum': [
                    'order',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('order',): {

                        "DESC": "desc",
                        "ASC": "asc"
                    },
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'address':
                        (str,),
                    'spent':
                        (bool,),
                    'check_mempool':
                        (bool,),
                    '_from':
                        (int,),
                    'to':
                        (int,),
                    'order':
                        (str,),
                    'page_token':
                        (str,),
                    'page_size':
                        (int,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                    'address': 'address',
                    'spent': 'spent',
                    'check_mempool': 'check_mempool',
                    '_from': 'from',
                    'to': 'to',
                    'order': 'order',
                    'page_token': 'page_token',
                    'page_size': 'page_size',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'address': 'path',
                    'spent': 'query',
                    'check_mempool': 'query',
                    '_from': 'query',
                    'to': 'query',
                    'order': 'query',
                    'page_token': 'query',
                    'page_size': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_utxoby_account
        )

        def __tx_create(
            self,
            tx_create,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Create an Unsigned Transaction  # noqa: E501

            Creates an unsigned transaction.  **Note** that Ethereum currently only supports singular transaction destinations.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.tx_create(tx_create, protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                tx_create (TxCreate):
                protocol (str): Protocol handle, one of: `avalanche`, `bitcoin`, `ethereum`, `dogecoin`, `fantom`, `polkadot`, `polygon`, `solana`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                UnsignedTx
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['tx_create'] = \
                tx_create
            return self.call_with_http_info(**kwargs)

        self.tx_create = _Endpoint(
            settings={
                'response_type': (UnsignedTx,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/tx/create',
                'operation_id': 'tx_create',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'tx_create',
                ],
                'required': [
                    'protocol',
                    'network',
                    'tx_create',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'tx_create':
                        (TxCreate,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'tx_create': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__tx_create
        )

        def __tx_send(
            self,
            signed_tx,
            protocol="bitcoin",
            network="mainnet",
            **kwargs
        ):
            """Submit a Signed Transaction  # noqa: E501

            Submit a signed transaction to the network.  **Note**: A successful transaction may still be rejected on chain or not processed due to a too low fee. You can monitor successful transactions through Universal websockets.   # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.tx_send(signed_tx, protocol="bitcoin", network="mainnet", async_req=True)
            >>> result = thread.get()

            Args:
                signed_tx (SignedTx):
                protocol (str): Protocol handle, one of: `algorand`, `avalanche`, `bitcoin`, `bitcoincash`, `dogecoin`, `ethereum`, `fantom`, `litecoin`, `optimism`, `polkadot`, `polygon`, `solana`. . defaults to "bitcoin", must be one of ["bitcoin"]
                network (str): Which network to target. Available networks can be found in the list of supported protocols or with /{protocol}.. defaults to "mainnet", must be one of ["mainnet"]

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                TxReceipt
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['protocol'] = \
                protocol
            kwargs['network'] = \
                network
            kwargs['signed_tx'] = \
                signed_tx
            return self.call_with_http_info(**kwargs)

        self.tx_send = _Endpoint(
            settings={
                'response_type': (TxReceipt,),
                'auth': [
                    'apiKeyAuthHeader',
                    'bearerAuth'
                ],
                'endpoint_path': '/{protocol}/{network}/tx/send',
                'operation_id': 'tx_send',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'protocol',
                    'network',
                    'signed_tx',
                ],
                'required': [
                    'protocol',
                    'network',
                    'signed_tx',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'protocol':
                        (str,),
                    'network':
                        (str,),
                    'signed_tx':
                        (SignedTx,),
                },
                'attribute_map': {
                    'protocol': 'protocol',
                    'network': 'network',
                },
                'location_map': {
                    'protocol': 'path',
                    'network': 'path',
                    'signed_tx': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__tx_send
        )
